/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


#ifndef __SHELLCFG_H
#define __SHELLCFG_H

	typedef struct
	{
		LPTSTR* pszBufCFG;
		UINT nBufCFG;

		LPTSTR* pszBufVAR;
		UINT nBufVAR;

		LPTSTR* pszFiles;
		UINT nFiles;

		LPTSTR* pszModules;
		UINT nModules;

		LPTSTR* pszFileFolders;
		UINT nFileFolders;

		LPTSTR* pszModFolders;
		UINT nModFolders;

		LPTSTR pConfigPath;
		LPTSTR pConfigSrc;
	} memBuffers;

	typedef struct
	{
		BOOL bEnableEndLineComments;
		BOOL bDisableEVars;
		BOOL bDisableExternalLoadModules;
		BOOL bColorBGR;
	} cfgSettings;

	/*---Private utility function declarations------------------------*/
	extern LPTSTR removeComment( LPTSTR );
	extern VOID copyBuffer( LPTSTR, LPCTSTR, UINT, BOOL, BOOL );
	extern BOOL enumList( UINT*, LPTSTR, LPCTSTR*, UINT );
	extern BOOL buildFolderList( LPTSTR**, UINT*, LPCTSTR );
	extern BOOL buildFileList( LPTSTR**, UINT*, LPCTSTR, LPCTSTR*, UINT, BOOL );
	extern BOOL buildVarList( LPTSTR**, UINT*, LPCTSTR );
	extern LPTSTR* allocateBuffer( LPTSTR*, UINT*, LPCTSTR );
	extern VOID freeBuffer( LPTSTR**, UINT* );
	extern LPTSTR searchBuf( UINT* const, LPCTSTR const );
	extern LPTSTR searchVar( LPCTSTR const );
	extern VOID delVar( LPCTSTR const );
	/*---Private setup function declarations--------------------------*/
	extern BOOL setupConfigPath( LPCTSTR, LPCTSTR );
	extern BOOL loadConfigBuffer( LPCTSTR, BOOL );
	extern BOOL parseDefaultConfig( VOID );
	extern BOOL parseDefinedConfig( VOID );
	extern BOOL parseLegacyConfig( VOID );

	#define SHELLCFG __declspec( dllexport )
	#include "../sdk/include/config.h"

#endif /*__SHELLCFG_H*/
