/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2002 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


#ifndef _INC_SHELLTRAY
#define _INC_SHELLTRAY

#define SS_NOTIFYTRAY      (WM_APP + 500)
#define NT_SETTRAYHWND     (0)
#define NT_SETTRAYMOVE     (1)
#define NT_SETTRAYSIZE     (2)

#define TEXT__SHELLTRAY_CLASS _T("Shell_TrayWnd")
#define TEXT__TRAYNOTIFY_CLASS _T("TrayNotifyWnd")

#define SHELLTRAY__GET_TRAYNOTIFY_WINDOW FindWindowEx(FindWindow(TEXT__SHELLTRAY_CLASS, _T("")), NULL, TEXT__TRAYNOTIFY_CLASS, _T(""))

typedef struct _NOTIFYICONDATASH
{
	DWORD cbSize;
	HWND  hWnd;
	UINT  uID;
	UINT  uFlags;
	UINT  uCallbackMessage;
	HICON hIcon;
	_TCHAR szTip[128];

	/* 9X/NT4 */

	DWORD dwState;
	DWORD dwStateMask;
	_TCHAR szInfo[256];

	union
	{
		UINT uTimeout;
		UINT uVersion;
	} DUMMYUNIONNAME;

	_TCHAR szInfoTitle[64];
	DWORD dwInfoFlags;

	/* 2K */

	GUID guidItem;

	/* XP */

} NOTIFYICONDATASH, *PNOTIFYICONDATASH;
typedef const NOTIFYICONDATASH * PCNOTIFYICONDATASH;

/*--------------------------------------------------------------------*/
/* the callback function used by both Enum & Register */
typedef BOOL (CALLBACK *SHTRAYCALLBACKPROC)( UINT, WPARAM, LPARAM );


#ifndef SHELLTRAY
#define SHELLTRAY __declspec( dllimport )
#endif

#ifdef __cplusplus
	extern "C" {
#endif

	/* Enum enumerates all current tray icons */
	SHELLTRAY BOOL WINAPI SS_EnumNotifyIcons( SHTRAYCALLBACKPROC );
	/* Register, registers the function for notifications of new tray events */
	SHELLTRAY BOOL WINAPI SS_RegisterCallback( SHTRAYCALLBACKPROC );
	/* UnRegister notifications of new tray events */
	SHELLTRAY BOOL WINAPI SS_UnregisterCallback( SHTRAYCALLBACKPROC );
	/* Creates our System Service window (tray notification and task list) */
	SHELLTRAY INT WINAPI SS_Main( BOOL );
	/* Initializes our 2k/xp tray services */
//	SHELLTRAY INT WINAPI SS_InitServices( VOID );

#ifdef __cplusplus
	};
#endif

#undef SHELLTRAY

#endif /* _INC_SHELLTRAY */
